public class Main_10_Comps {

	public static void main(String[] args) {
		try {

/*			Architecture arch = new Architecture(4, 4);
			arch.setProcessMemReq(21);
			arch.setAvailableMem(200);
			arch.setProcessCPUReq(107);
			arch.setAvailableCPU(1000);

			// Communication Connector
			arch.setComponentReliability(0, 0.999);
			arch.deployComponent(0, 1);
			arch.setMaxReplicas(0, 1);
			arch.setComponentMemUsage(0, 10);
			arch.setComponentCPUUsage(0, 100);
			// Controller
			arch.setComponentReliability(1, 0.997);
			arch.deployComponent(1, 2);
			arch.setMaxReplicas(1, 1);
			arch.setComponentMemUsage(1, 20);
			arch.setComponentCPUUsage(1, 150);
			// Navigator
			arch.setComponentReliability(2, 0.998);
			arch.deployComponent(2, 0);
			arch.setMaxReplicas(2, 1);
			arch.setComponentMemUsage(2, 15);
			arch.setComponentCPUUsage(2, 120);
			// Actuator
			arch.setComponentReliability(3, 0.999);
			arch.deployComponent(3, 0);
			arch.setMaxReplicas(3, 1);
			arch.setComponentMemUsage(3, 25);
			arch.setComponentCPUUsage(3, 110);

			// System Operational Profile
			double[][] opProfile = new double[5][5];
			opProfile[0][1] = 1;
			opProfile[1][2] = 0.25;
			opProfile[1][3] = 0.5;
			opProfile[1][4] = 0.25;
			opProfile[2][1] = 1;
			opProfile[3][1] = 1;
			arch.setOperationalProfile(opProfile);

			// Display current architecture
			arch.show();
			// Show Optimum architecture
			long start = System.currentTimeMillis();
			arch.optimizeArchitecture_New(opProfile, 99);
			long elapsedTimeMillis = System.currentTimeMillis() - start;
			System.out.println("Elapsed time : " + elapsedTimeMillis);*/
			
			Architecture arch = new Architecture(10, 10);
			arch.setProcessMemReq(21);
			arch.setAvailableMem(2000);
			arch.setProcessCPUReq(107);
			arch.setAvailableCPU(10000);

			// Communication Connector
			arch.setComponentReliability(0, 0.999);
			arch.deployComponent(0, 1);
			arch.setMaxReplicas(0, 1);
			arch.setComponentMemUsage(0, 10);
			arch.setComponentCPUUsage(0, 100);
			// Controller
			arch.setComponentReliability(1, 0.997);
			arch.deployComponent(1, 2);
			arch.setMaxReplicas(1, 1);
			arch.setComponentMemUsage(1, 20);
			arch.setComponentCPUUsage(1, 150);
			// Navigator
			arch.setComponentReliability(2, 0.998);
			arch.deployComponent(2, 0);
			arch.setMaxReplicas(2, 1);
			arch.setComponentMemUsage(2, 15);
			arch.setComponentCPUUsage(2, 120);
			// Actuator
			arch.setComponentReliability(3, 0.999);
			arch.deployComponent(3, 0);
			arch.setMaxReplicas(3, 1);
			arch.setComponentMemUsage(3, 25);
			arch.setComponentCPUUsage(3, 110);
			
			// Communication Connector
			arch.setComponentReliability(4, 0.999);
			arch.deployComponent(4, 3);
			arch.setMaxReplicas(4, 1);
			arch.setComponentMemUsage(4, 10);
			arch.setComponentCPUUsage(4, 100);
			// Controller
			arch.setComponentReliability(5, 0.997);
			arch.deployComponent(5, 0);
			arch.setMaxReplicas(5, 1);
			arch.setComponentMemUsage(5, 20);
			arch.setComponentCPUUsage(5, 150);
			// Navigator
			arch.setComponentReliability(6, 0.998);
			arch.deployComponent(6, 1);
			arch.setMaxReplicas(6, 1);
			arch.setComponentMemUsage(6, 15);
			arch.setComponentCPUUsage(6, 120);
			// Actuator
			arch.setComponentReliability(7, 0.999);
			arch.deployComponent(7, 2);
			arch.setMaxReplicas(7, 1);
			arch.setComponentMemUsage(7, 25);
			arch.setComponentCPUUsage(7, 110);
			
			arch.setComponentReliability(8, 0.998);
			arch.deployComponent(8, 3);
			arch.setMaxReplicas(8, 1);
			arch.setComponentMemUsage(8, 15);
			arch.setComponentCPUUsage(8, 120);
			// Actuator
			arch.setComponentReliability(9, 0.999);
			arch.deployComponent(9, 0);
			arch.setMaxReplicas(9, 1);
			arch.setComponentMemUsage(9, 25);
			arch.setComponentCPUUsage(9, 110);

			// System Operational Profile
			double[][] opProfile = new double[9][9];
			opProfile[0][1] = 1;
			opProfile[2][1] = 1;
			opProfile[3][1] = 1;
			opProfile[4][1] = 1;
			opProfile[5][1] = 1;
			opProfile[6][1] = 1;
			opProfile[7][1] = 1;
			opProfile[8][1] = 1;
			opProfile[9][1] = 1;
			
			opProfile[1][2] = 0.05;
			opProfile[1][3] = 0.15;
			opProfile[1][4] = 0.10;
			opProfile[1][5] = 0.10;
			opProfile[1][6] = 0.05;
			opProfile[1][7] = 0.15;
			opProfile[1][8] = 0.20;
			opProfile[1][9] = 0.05;
			opProfile[1][10] = 0.15;

			
			arch.setOperationalProfile(opProfile);

			// Display current architecture
			arch.show();
			// Show Optimum architecture
			long start = System.currentTimeMillis();
			arch.optimizeArchitecture_New(opProfile, 99);
			long elapsedTimeMillis = System.currentTimeMillis() - start;
			System.out.println("Elapsed time : " + elapsedTimeMillis);


		} catch (Exception ex) {
			System.out.print(ex.toString());
		}
	}
}